Unit AMS1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AMC1C_p;

procedure AMS1C(N :Integer; M :Integer; Q :Real;
                var B :Array of Complex; var X :Array of Complex);

implementation

procedure AMS1C(N :Integer; M :Integer; Q :Real;
                var B :Array of Complex; var X :Array of Complex);
var
I,N1,N2,N3 :Integer;
R :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
N2 := 2*N;
if ( Q ) < 0
 then goto _3
 else if ( Q ) > 0
       then goto _1
       else goto _3;
_1:
N1 := N-1;
for I:=1 to N1 do
 begin
  N3 := N2-I;
  R := B[I-1];
  B[I-1] := B[N3-1];
_2:
  B[N3-1] := R;
 end;
_3:
N1 := N+1;
N3 := N2-1;
for I:=N1 to N3 do
 begin
_4:
  X[I-1] := Cmplx(0.0,0.E0);
 end;
if ( M-N3 ) < 0
 then goto _7
 else if ( M-N3 ) > 0
       then goto _5
       else goto _7;
_5:
for I:=N2 to M do
 begin
  B[I-1] := Cmplx(0.0,0.E0);
_6:
  X[I-1] := Cmplx(0.0,0.E0);
 end;
_7:
AMC1C(M,B,X);
N1 := N-1;
if ( Q ) < 0
 then goto _10
 else if ( Q ) > 0
       then goto _8
       else goto _10;
_8:
for I:=1 to N1 do
 begin
  N3 := N2-I;
_9:
  X[I-1] := X[N3-1];
 end;
goto _12;
_10:
for I:=1 to N do
 begin
  N3 := N1+I;
_11:
  X[I-1] := X[N3-1];
 end;
_12:
end;

end.
